<template>
  <div>
    <div class="car_series">
      <div class="count">
        <button @click="showModal">新增车型</button>
        <Count :sum="sum"></Count>
      </div>
      <div class="table">
        <Table
          :tableData="tableData"
          @edit="edit"
          @delet_data="deleteData"
          :pageSize="sum"
        ></Table>
      </div>
      <div class="page">
        <Tablepage
          :totalPage="totalPage"
          :currentPage="currentPage"
          @change_page="changePage"
          @jump_page="jumpPage"
        ></Tablepage>
      </div>
      <div class="modal" v-if="modalFlag">
        <Modal
          :modalFlag="modalFlag"
          @submit="submit"
          @hide_modal="showModal"
        ></Modal>
      </div>
    </div>
  </div>
</template>

<script>
import Count from "../../../../components/Count";
import Tablepage from "../../../../components/TablePage";
import Table from "./CarTypeTable";
import Modal from "./CarTypeModal";

export default {
  components: {
    Count,
    Table,
    Tablepage,
    Modal,
  },
  data() {
    return {
      sum: 0, // 一共有多少条数据
      pageSize: 20, // 每页展示的数据
      currentPage: 1,
      tableData: [],
      modalFlag: false, // 控制模态框展示
      parentId: (this.$route.query && this.$route.query.id) || "",
    };
  },
  computed: {
    // 表格总页数
    totalPage() {
      return Math.ceil(this.sum / this.pageSize);
    },
  },
  methods: {
    // 获取某一页面的数据，展示在表格
    changePage: function (page) {
      this.currentPage = page;
      this.getData(this.currentPage, this.pageSize);
    },
    // 点击上一页，下一页，首页，尾页
    jumpPage: function (item) {
      switch (item) {
        case 1:
          this.currentPage = 1;
          break;
        case 2:
          this.currentPage = this.currentPage - 1;
          break;
        case 3:
          this.currentPage = this.currentPage + 1;
          break;
        case 4:
          this.currentPage = this.totalPage;
          break;
      }
      this.getData(this.currentPage, this.pageSize);
    },
    // 展示、隐藏模态框
    showModal: function () {
      this.modalFlag = !this.modalFlag;
    },
    // 点击编辑
    edit(index, newName) {
      let id = this.tableData[index]["id"];
      let req = {
        id,
        typeName: newName,
        parentId: this.parentId,
      };
      this.updataCarTypeInfo(req).then(() => {
        this.getData(this.currentPage, this.pageSize);
      });
    },
    // 点击删除
    deleteData(index) {
      let id = this.tableData[index]["id"];
      this.deleteCarTypeInfo(id).then(() => {
        this.currentPage = Math.ceil((this.sum - 1) / this.pageSize);
        this.getData(this.currentPage, this.pageSize);
      });
    },
    // 新增车型模态框 保存
    submit: function (car) {
      this.addCarSeries(car).then(() => {
        this.currentPage = Math.ceil((this.sum + 1) / this.pageSize);
        this.getData(this.currentPage, this.pageSize);
        this.modalFlag = false;
      });
    },
    // 获取数据  接口
    getData: function (page, rows) {
      this.$http({
        method: "post",
        url: "/base/carTypeManager/selectCarTypePage",
        data: {
          parentId: this.parentId,
          page,
          rows,
        },
      })
        .then((res) => {
          if (res.data && res.data.code === 200) {
            console.log(res);
            this.tableData = res.data.data;
            this.sum = res.data.count;
          } else {
            console.log(res);
          }
        })
        .catch((err) => {
          console.log(err);
        });
    },
    // 新增车型  接口
    addCarSeries: function (typeName) {
      return new Promise((resolve, reject) => {
        this.$http({
          url: "/base/carTypeManager/addCarTypeInfo",
          method: "post",
          data: {
            typeName: typeName,
            parentId: this.parentId,
          },
        })
          .then((res) => {
            if (res.data && res.data.code === 200) {
              resolve();
            } else {
              alert("新增失败，请重试");
              console.log(res);
            }
          })
          .catch((err) => {
            alert("新增失败，请重试");
            reject(err);
          });
      });
    },
    // 编辑车型   接口
    updataCarTypeInfo: function (data) {
      return new Promise((resolve, reject) => {
        this.$http({
          url: "/base/carTypeManager/updateCarTypeInfo",
          method: "post",
          data,
        })
          .then((res) => {
            if (res.data && res.data.code === 200) {
              resolve();
            } else {
              alert("编辑失败，请重试");
              console.log(res);
            }
          })
          .catch((err) => {
            alert("编辑失败，请重试");
            reject(err);
          });
      });
    },
    // 删除车型   接口
    deleteCarTypeInfo: function (id) {
      return new Promise((resolve, reject) => {
        this.$http({
          url: "/base/carTypeManager/deleteCarTypeInfo",
          method: "post",
          data: {
            parentId: this.parentId,
            id,
          },
        })
          .then((res) => {
            if (res.data && res.data.code === 200) {
              resolve();
            } else {
              alert("删除失败，请重试");
              console.log(res);
            }
          })
          .catch((err) => {
            alert("删除失败，请重试");
            reject(err);
          });
      });
    },
  },
  mounted() {
    this.getData(this.currentPage, this.pageSize);
    console.log(this.parentId);
  },
};
</script>

<style scoped lang="less">
.car_series {
  .count {
    height: 40px;
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    button {
      width: 86px;
      height: 30px;
      position: relative;
      bottom: -5px;
      margin: 0;
      border-radius: 2px;
    }
  }
}
</style>
